int blue = 6;                                                       //Der Ausgang für das Blau Signal ist 6 (vorher 11)
int green = 5;                                                     //Der Ausgang für das Grün Signal ist 5 (vorher 10) 
int red = 3;                                                           //Der Ausgang für das rot Signal ist 3 8vorher 9)

int licht1 = 2;
int brunnen = 4;
int leute = 7;
int feuer = 8;
int fahrrad = 12;
int frei = 13;


int b = 30;                     //Länge eines Blitzes
int HWolk = 10;       //Helligkeit bei Gewitter (zwischen 0 und 255)
int paus = 1000;  //Pause zwischen Blitzen
int ZB = 1;      //Anzahl Blitze in einer Folge
int x = 0;        // Zufallszahl zw. 1 u. 5, damit es nur an jedem 5. Tag gewittert


int analogPin = A0;                 //Spannung an A0 (Poti) soll ausgelesen werden A0 ist die Variable analogPin    
long G = 1000;          //Geschwindigkeit für Tag, die per Potentiometerwert an A0 ausgelesen wird zwischen 0 und 1023
int z = 12;       //Verhältnis von G zu p. Der Wert von G (0 bis 1023) wird durch z geteilt, um p zu ermitteln. p = G / z

int p = 30;      // p ist die kurze Wartezeit für praktisch alles. Z.B. Geschwindigkeit beim Farbwechsel
long P = 20000;     //P benutze ich für die großen Pausen (Tag und Nacht) in Millisekunden
int y = 120;       //Verhältnis von G zu P d.h. P ist G * y

long T = 5000;                  //Restzeit nach Gewitter

int i = 0;           // Zähler
                                
                                                                            //da der Wert größer als 32.767 ist, muss anstatt "int" "long" verwendet werden
int Hblue = 0;                                                     //Hblue steht für den blauen PWM Wert (0-255)
int Hgreen = 0;                                                     //Hgreen steht für den grünen PWM Wert (0-255)
int Hred = 0;                                                       //Hred steht für den roten PWM Wert (0-255)
 
void setup() {
  
  pinMode(blue, OUTPUT);                                  //blue (6) ist jetzt ein Ausgang - ob PWM oder digital muss nicht definiert werden
  pinMode(green, OUTPUT);                                //green (5) ist jetzt ein Ausgang
  pinMode(red, OUTPUT);                                 //red (3) ist jetzt ein Ausgang
  pinMode(licht1, OUTPUT);                              //licht1 (2) ist jetzt ein Ausgang
  pinMode(fahrrad, OUTPUT);                              //licht2 (4) ist jetzt ein Ausgang
  pinMode(leute, OUTPUT);                              //leute (7) ist jetzt ein Ausgang
  pinMode(feuer, OUTPUT);                              //feuer (8) ist jetzt ein Ausgang
  pinMode(analogPin, INPUT);                                  //A5 wird als INPUT für Poti gesetzt
  pinMode(brunnen, OUTPUT);
  pinMode(frei, OUTPUT);

Serial.begin(9600);                         // Setup der seriellen Verbindung
}

void loop() {

 digitalWrite(licht1, HIGH);                             //licht1 an
 Serial.println("Tag beginnt"); 
 Serial.print(G);              // Wert ausgeben
 Serial.print("; ");
 Serial.print(P);
 Serial.print("; ");
 Serial.println(p);
 delay(100 * p); 
  
  while (Hblue <= 40)                                          //eine "while"-Schleife beginnt -
                                                                             //Solange die Bedingung wahr ist, wird die folgende Geschweifte Klammer wiederholt
  {                                                         //In dieser Schleife wird von einem Nächtlichen blau/rot ein Sonnenaufgang blau/rot
    
    analogWrite(blue, Hblue);                                //der Wert von Hblue (aktuell 20) wird als PWM auf den Ausgang 11 geschrieben
    analogWrite(green, Hgreen);                           //der Wert von Hgreen (aktuell 0) wird als PWM auf den Ausgang 10 geschrieben
    analogWrite(red, Hred);                                   //der Wert von Hred (aktuell 20) wird als PWM auf den Ausgang 9 geschrieben
  
    digitalWrite(brunnen, LOW);                            // licht2 an
    digitalWrite(fahrrad, LOW);                            // fahrrad ist invertiert, damit man es auch bei ausgeschaltetem Arduino schalten kann
    delay(p);                                             //eine mittlere Pause
    
    Hblue ++;                                                        //Die Helligkeit von blau wird um 1 gesteigert.
  }

G = analogRead(analogPin);                //schreibt den Wert von PIN A0 in Variable G
p = G / z;                         
P = G * y;
Serial.print(G);              // Wert ausgeben
 Serial.print("; ");
 Serial.print(P);
 Serial.print("; ");
 Serial.println(p);
Hblue = 40;
Hgreen = 0;
Hred = 0;



while (Hred <= 100)                                          //eine "while"-Schleife beginnt -
                                                                             //Solange die Bedingung wahr ist, wird die folgende Geschweifte Klammer wiederholt
  {                                                                          //In dieser Schleife wird von einem Nächtlichen blau/rot ein Sonnenaufgang blau/rot
    analogWrite(blue, Hblue);                                //der Wert von Hblue (aktuell 20) wird als PWM auf den Ausgang 11 geschrieben
    analogWrite(green, Hgreen);                           //der Wert von Hgreen (aktuell 0) wird als PWM auf den Ausgang 10 geschrieben
    analogWrite(red, Hred);                                   //der Wert von Hred (aktuell 20) wird als PWM auf den Ausgang 9 geschrieben
    delay(p);                                             //eine kleine Pause
    Hred ++;                                             //Die Helligkeit von brot wird um 1 gesteigert
  }


  while (Hred <= 255)                                          //eine "while"-Schleife beginnt -
                                                                             //Solange die Bedingung wahr ist, wird die folgende Geschweifte Klammer wiederholt
  {                                                                          //In dieser Schleife wird von einem Nächtlichen blau/rot ein Sonnenaufgang blau/rot
    analogWrite(blue, Hblue);                                //der Wert von Hblue (aktuell 20) wird als PWM auf den Ausgang 11 geschrieben
    analogWrite(green, Hgreen);                           //der Wert von Hgreen (aktuell 0) wird als PWM auf den Ausgang 10 geschrieben
    analogWrite(red, Hred);                                   //der Wert von Hred (aktuell 20) wird als PWM auf den Ausgang 9 geschrieben
    delay(p);                                                          //eine kleine Pause
    Hblue ++;                                                        //Die Helligkeit von blau wird um 1 gesteigert.
    Hred ++;                                    //Nicht nur blau muss heller werden, auch rot steig in jeder Runde der Schleife um 1

  }
G = analogRead(analogPin);                //schreibt den Wert von PIN A0 in Variable G
    p = G / z;                         
    P = G * y;
 Serial.print(G);              // Wert ausgeben
 Serial.print("; ");
 Serial.print(P);
 Serial.print("; ");
 Serial.println(p);           // Wert ausgeben

digitalWrite(licht1, LOW);
delay(200 * p);


 
  Hblue = 255;                                                     //
  Hgreen = 0;                                                      // Zwischenstand der Werte
  Hred = 255;                                                      //

delay(200 * p);

digitalWrite(leute, HIGH);                                  // Männchen fangen an, sich zu bewegen

 
  while (Hgreen <= 255)                                      //in dieser Schleife fahren wir das grün hoch - aus dem Morgenrot wird Tageslicht weiß
  {
    analogWrite(blue, Hblue);
    analogWrite(green, Hgreen);
    analogWrite(red, Hred);
    delay(p);
    Hgreen ++;
  }
  Hblue = 255;                                                      //
  Hgreen = 255;                                                   // Zwischenstand der Werte
  Hred = 255;                                                       //

 digitalWrite(brunnen,HIGH);

 delay(200 * p);

 digitalWrite(fahrrad, HIGH);

G = analogRead(analogPin);                //schreibt den Wert von PIN A0 in Variable G
    p = G / z;                         
    P = G * y;
 Serial.print(G);              // Wert ausgeben
 Serial.print("; ");
 Serial.print(P);
 Serial.print("; ");
 Serial.println(p);


digitalWrite(feuer, LOW);

x = random(4);      // x bekommt einen zufälligen ganzzahligen Wert zwischen 1 und 4

if (x == 1) {        // wenn x = 1 ist, soll die nachfolgende Gewittersequenz laufen, sonst nicht. Bei x = random(4): Chance 1 zu 4
                  
  T = random(P);    // T ist ein zufälliger Teil von P, der langen Tagespause
  delay(T);         // Das Gewitter soll zufällig nach delay(T) losgehen

  HWolk = random(20, 100);    // HWolk ist die Helligkeit bei Gewitterwolken. Hier zufällig zwischen 10 und 100
  
                                                         

 while (Hgreen >= HWolk)        // in der folgenden Sequenz wird auf den zufälligen Wert HWolk abgedimmt                                  
  {
    analogWrite(blue, Hblue);
    analogWrite(green, Hgreen);
    analogWrite(red, Hred);
    delay(p);
    Hgreen --;
    Hred --;
    Hblue --;
  }

if (HWolk < 70)
{
  digitalWrite(licht1, HIGH);
}

ZB = random(1, 20);       // Es wird eine zufällige Anzahl von Blitzen zwischen 1 und 20 festgelegt
i = 0;
while (i < ZB)            // Wiederholungsschleife, bis zufällige Anzahl Blitze erreicht ist
{
 
 Hblue = 255;         // Blitz mit voller Helligkeit, Blitzdauer = delay(b)                                              
 Hgreen = 255;                                                   
 Hred = 255;   
 analogWrite(blue, Hblue);
 analogWrite(green, Hgreen);
 analogWrite(red, Hred);
 delay(b);
 
Hblue = 0;          // nach Blitz volle Dunkelheit (Dauer wieder b)                                             
 Hgreen = 0;                                                   
 Hred = 0;   
 analogWrite(blue, Hblue);
 analogWrite(green, Hgreen);
 analogWrite(red, Hred);
 delay(b);

i = i+1;          // Zähler Blitze wird raufgezählt
}

digitalWrite(fahrrad, LOW);

HWolk = random(10, 50);   // Helligkeit wird zwischen Blitzen zufallsmäßig zwischen 10 und 50 eingestellt:

digitalWrite(leute, LOW);         //Leute hören auf, sich zu bewegen

Hblue = HWolk;                                                      
 Hgreen = HWolk;                                                   
 Hred = HWolk;   
 analogWrite(blue, Hblue);
 analogWrite(green, Hgreen);
 analogWrite(red, Hred);
 delay(random(8000));         // Pause von 8 Sekunden zwischen Blitzen
 
ZB = random(1, 15);           // Es wird wieder eine zufällige Anzahl von Blitzen diesmal zwischen 1 und 15 festgelegt
i = 0;
while (i < ZB)
{
 
 Hblue = 255;               // wieder volle Helligkeit für Blitz, Dauer wieder = b                                            
 Hgreen = 255;                                                   
 Hred = 255;   
 analogWrite(blue, Hblue);
 analogWrite(green, Hgreen);
 analogWrite(red, Hred);
 delay(b);
 
Hblue = 0;                                                      
 Hgreen = 0;                                                   
 Hred = 0;   
 analogWrite(blue, Hblue);
 analogWrite(green, Hgreen);
 analogWrite(red, Hred);
 delay(b);

i = i+1;
}

HWolk = random(10, 100);

if (HWolk < 70)
{
  digitalWrite(licht1, HIGH);
}

Hblue = HWolk;                                                      
 Hgreen = HWolk;                                                   
 Hred = HWolk;   
 analogWrite(blue, Hblue);
 analogWrite(green, Hgreen);
 analogWrite(red, Hred);
 delay(random(8000));

 ZB = random(1, 10);
i = 0;
while (i < ZB)
{
 Hblue = 255;                                                      
 Hgreen = 255;                                                   
 Hred = 255;   
 analogWrite(blue, Hblue);
 analogWrite(green, Hgreen);
 analogWrite(red, Hred);
 delay(b);
 
Hblue = 0;                                                      
 Hgreen = 0;                                                   
 Hred = 0;   
 analogWrite(blue, Hblue);
 analogWrite(green, Hgreen);
 analogWrite(red, Hred);
 delay(b);

i = i+1;
}

HWolk = random(10, 120);

Hblue = HWolk;                                                      
 Hgreen = HWolk;                                                   
 Hred = HWolk;   
 analogWrite(blue, Hblue);
 analogWrite(green, Hgreen);
 analogWrite(red, Hred);
 delay(random(8000));

while (Hgreen <= 255)                                          // langsam wird wieder alles bis auf volle Helligkeit erhöht (delay b)
  {
    analogWrite(blue, Hblue);
    analogWrite(green, Hgreen);
    analogWrite(red, Hred);
    delay(p);
    Hgreen ++;
    Hred ++;
    Hblue ++;
  }

digitalWrite(licht1, LOW);

  Hblue = 255;                                                      //
  Hgreen = 255;                                                   // Zwischenstand der Werte
  Hred = 255;    


digitalWrite(feuer, HIGH);

delay(200 * p);

digitalWrite(leute,HIGH);

delay(200 * p);

digitalWrite(fahrrad, HIGH);
}

G = analogRead(analogPin);                //schreibt den Wert von PIN A0 in Variable G
    p = G / z;                         
    P = G * y;
 Serial.print(G);              // Wert ausgeben
 Serial.print("; ");
 Serial.print(P);
 Serial.print("; ");
 Serial.println(p);
delay(P/5);  

G = analogRead(analogPin);                //schreibt den Wert von PIN A0 in Variable G
    p = G / z;                         
    P = G * y;
 Serial.println(G);              // Wert ausgeben
delay(P/5); 
 
G = analogRead(analogPin);                //schreibt den Wert von PIN A0 in Variable G
    p = G / z;                         
    P = G * y;
 Serial.println(G);              // Wert ausgeben
delay(P/5);  

G = analogRead(analogPin);                //schreibt den Wert von PIN A0 in Variable G
    p = G / z;                         
    P = G * y;
 Serial.println(G);              // Wert ausgeben
delay(P/5);  


G = analogRead(analogPin);                //schreibt den Wert von PIN A0 in Variable G
    p = G / z;                         
    P = G * y;
 Serial.print(G);              // Wert ausgeben
 Serial.print("; ");
 Serial.print(P);
 Serial.print("; ");
 Serial.println(p);
delay(P/5);


  while (Hgreen >= 10)                                          //in deiser Schleife nehmen wir den grün Anteil heraus - Abendrot
  {
    analogWrite(blue, Hblue);
    analogWrite(green, Hgreen);
    analogWrite(red, Hred);
    delay(p);
    Hgreen --;                                                       //sowie ++ den Wert immer um 1 anhebt, senkt -- den Wert immer um 1
  }
  Hblue = 255;                                                      //
  Hgreen = 10;                                                       // Zwischenstand der Werte
  Hred = 255;                                                       //
  
  while (Hblue >= 4)                                           //in dieser Schleife senken wir die Helligkeit des rot/blau Gemisches 
  {
    analogWrite(blue, Hblue);
    analogWrite(green, Hgreen);
    analogWrite(red, Hred);
    delay(p);
    Hblue --;
  }
  
digitalWrite(licht1, HIGH);

while (Hred >= 8)                                           //in dieser Schleife senken wir die Helligkeit des rot/blau Gemisches 
  {
    analogWrite(blue, Hblue);
    analogWrite(green, Hgreen);
    analogWrite(red, Hred);
    delay(p);
    Hred --;
  }

G = analogRead(analogPin);                //schreibt den Wert von PIN A0 in Variable G
    p = G / z;                         
    P = G * y;
 Serial.print(G);              // Wert ausgeben
 Serial.print("; ");
 Serial.print(P);
 Serial.print("; ");
 Serial.println(p);

while (Hblue >= 3)                                           //in dieser Schleife senken wir die Helligkeit des rot/blau Gemisches 
  {
    analogWrite(blue, Hblue);
    analogWrite(green, Hgreen);
    analogWrite(red, Hred);
    delay(p);
    Hblue --;
    Hred --;
    Hgreen --;
  }

  
  Hblue = 3;                                                       //
  Hgreen = 0;                                                      // Zwischenstand der Werte
  Hred = 0; 
  analogWrite(blue, Hblue);
    analogWrite(green, Hgreen);
    analogWrite(red, Hred);

G = analogRead(analogPin);                //schreibt den Wert von PIN A0 in Variable G
    p = G / z;                         
    P = G * y;

 Serial.print(G);              // Wert ausgeben
 Serial.print("; ");
 Serial.print(P);
 Serial.print("; ");
 Serial.println(p);
 
 T = random(P); 
  
  delay(T);
  digitalWrite(leute, LOW);
  delay(p * 200);
  digitalWrite(brunnen, LOW);
  delay(p * 200);
  digitalWrite(fahrrad, LOW);
  delay(P-T / 2);

G = analogRead(analogPin);                //schreibt den Wert von PIN A0 in Variable G
    p = G / z;                         
    P = G * y;
 Serial.print(G);              // Wert ausgeben
 Serial.print("; ");
 Serial.print(P);
 Serial.print("; ");
 Serial.println(p);
  
  digitalWrite(licht1, LOW);
  delay(P-T / 2);
  
  Hblue = 0;
   analogWrite(blue, Hblue);

  G = analogRead(analogPin);                //schreibt den Wert von PIN A0 in Variable G
    p = G / z;                         
    P = G * y;
 Serial.print(G);              // Wert ausgeben
 Serial.print("; ");
 Serial.print(P);
 Serial.print("; ");
 Serial.println(p);
}                                                                          // und nun beginnt alles wieder von vorn.
